#!/usr/local/bin/perl
#----------------------------------------------------
# select.pl
#----------------------------------------------------
# --Finds historical data file for the selected stock
# --Outputs information about stock
# --Plots a graph with historical data 
#----------------------------------------------------


require "/home/B6H/development/deneb_cgi-bin/miloje/cgi_handlers.pl";

$DATA_DIR = "/home/B6H/development/document_root/users/miloje/Demo/Data";
$NETPBM_DIR = "/home/B8E/miloje/netpbm/bin";
$TMP_DIR = "/home/B6H/development/document_root/users/miloje/Demo/tmp";
$TMP_URL = "http://deneb.npac.syr.edu:3768/users/miloje/Demo/tmp";
$SCRIPT_ROOT_URL = "http://deneb.npac.syr.edu:3768/cgi-bin/miloje";

&get_request;
$rqpairs{'symbol'}="AMAT";
$symbol = $rqpairs{'symbol'};
$hfile = "$DATA_DIR/history.$symbol";
$pid = $$;

if($symbol ne "") {
  $_ = `wc -l $hfile`;
  ($ndata, $junk) = /(\d+) (\w+)/;
} else {
  print "Could not find the symbol, try again"
};

$PriceType = 1;

$gnu_file = "$symbol.$pid.gnu";
$plot_data = "chart.$symbol.$pid.dat";
$ppm_chartfile = "chart.$symbol.$pid.ppm";
$gif_chartfile = "chart.$symbol.$pid.gif";
$gif_chartURL  = "$TMP_URL/chart.$symbol.$pid.gif";


open(HISTORY,$hfile);
open(CHART_DATA, ">$TMP_DIR/$plot_data") || die "couldn't open $plot_data";
$index=0;
while(<HISTORY>) {
 $index++;
 ($date, $low, $high, $close, $vol1, $vol2)=split;
 $stock{"date"} = $date;
 $stock{"low"} = $low;
 $stock{"high"} = $high;
 $stock{"close"} = $close;
 $stock{"vol1"} = $vol1;
 $stock{"vol2"} = $vol2;
 print(CHART_DATA "$index $close\n");
 ($year,$month,$day)=/(\d{2})(\d{2})(\d{2})/;
 if($index eq 1) {
   $first{"year"}=$year;
   $first{"month"}=$month;
   $first{"day"}=$day;
   $first{"low"} = $low;
   $first{"high"} = $high;
   $first{"close"} = $close;
   $first{"vol1"} = $vol1;
   $first{"vol2"} = $vol2;
 }
}
$last{"year"}=$year;
$last{"month"}=$month;
$last{"day"}=$day;
$last{"low"}=$low;
$last{"high"}=$high;
$last{"close"}=$close;
$last{"vol1"}=$vol1;
$last{"vol2"}=$vol2;

close(HISTORY);
close(CHART_DATA);


#eval `rm -f $TMP_DIR/$ppm_chartfile 2>/dev/null`;
#NOTE: gnuplot expects "pbm", even though it actually writes out a PPM file
open(OUTPUT, ">$TMP_DIR/$gnu_file") || die "couldn't open $gnu_file";
print(OUTPUT "set term pbm small\n");
print(OUTPUT "cd \"$TMP_DIR\" \n");
#print(OUTPUT "set term postscript\n");
# the default size 1, 1 produces a 640x480 size chart...
print(OUTPUT "set size 0.72, 0.54\n");
print(OUTPUT "set output \"$ppm_chartfile\" \n");
#print(OUTPUT "set output \"$ps_chartfile\" \n");
print(OUTPUT "set title \"Historical Price Chart for $symbol\" \n");
print(OUTPUT "set grid\n");
print(OUTPUT "set nolabel\n");
print(OUTPUT "plot \"$plot_data\" using 2 with lines\n");
close(OUTPUT);
eval `cd $TMP_DIR; /usr/local/bin/gnuplot $gnu_file`;
#eval `rm -f $TMP_DIR/$gif_chartfile 2>/dev/null`;
eval `$TMP_DIR/bin/ppmtogif $TMP_DIR/$ppm_chartfile > $TMP_DIR/$gif_chartfile 2>/dev/null`;

#eval `rm -f *.ppm *.dat 2>/dev/null`;

&html_header("Historical Price Chart");
print "<h1> Daily Closing Prices </h1>";
print "<hr>";
print "<pre>";
print "Start: $first{'year'}/$first{'month'}/$first{'day'}  Closing price: $first{'close'}\n"; 
print "End  : $last{'year'}/$last{'month'}/$last{'day'}  Closing price: $last{'close'}\n"; 
print "</pre>";
print "<hr>";
print "<img src=\"http://deneb.npac.syr.edu:3768/users/miloje/Demo/tmp/$gif_chartfile\">";
print "<hr>";
print "<h2>Configure Calibration</h2>";
print "<hr>";
print "<FORM METHOD=POST ACTION=http://deneb.npac.syr.edu:3768/cgi-bin/miloje/calibrate.cgi>";
print "<INPUT TYPE=hidden NAME=symbol VALUE=$rqpairs{'symbol'}>";
print "<INPUT TYPE=hidden NAME=last_closing VALUE=$last{'close'}>";
print "Period length:"; 
print <<STOP;
               <SELECT NAME="time_unit">
               <OPTION VALUE="1"> One day
               <OPTION VALUE="5"> One week
               <OPTION SELECTED VALUE="22"> One month
               <OPTION VALUE="260"> One year
            </SELECT> 
STOP
print "Number of periods for calibration:";
print "<INPUT TYPE=text NAME=ndata SIZE=4 VALUE=1000>";
print "<hr>";
print "Number of histogram bins:";
print "<INPUT TYPE=text NAME=nhbins SIZE=3 VALUE=20>";
print "Histogram width:";
print <<STOPSD;
               <SELECT NAME="nsd">
               <OPTION SELECTED VALUE="3"> 6 standard deviations
               <OPTION VALUE="4"> 8 standard deviations
               <OPTION VALUE="5"> 10 standard deviations
            </SELECT> 
STOPSD
print "<hr>";
print "<b><INPUT TYPE=SUBMIT VALUE=Calibrate></b>"; 
print "using";
print <<DSTOP;
               <SELECT NAME=dtype SELECTED="Gaussian">
               <OPTION VALUE="1"> Gaussian
               <OPTION VALUE="5"> Generalized Cauchy
              </SELECT> 
DSTOP
print "distribution or";
print " <INPUT TYPE=RESET VALUE=Cancel>";

print "</body>";
print "</html>";
exit;
